Home Information Classes Download Usage Mail List Requirements Links Tutorial

# TcpWvOut Class Reference

STK internet streaming output class. More...

`#include <TcpWvOut.h>`

Inheritance diagram for TcpWvOut:

List of all members.

## Public Member Functions

| TcpWvOut ()
| Default constructor ... the socket is not instantiated.
| TcpWvOut (int port, const char *hostname="localhost", unsigned int nChannels=1, Stk::STK_FORMAT format=STK_SINT16)
| Overloaded constructor which opens a network connection during instantiation.
| ~TcpWvOut ()
| Class destructor.
void | connect (int port, const char *hostname="localhost", unsigned int nChannels=1, Stk::STK_FORMAT format=STK_SINT16)
| Connect to the specified host and port and prepare to stream nChannels of data in the given data format.
void | disconnect (void)
| If a connection is open, write out remaining samples in the queue and then disconnect.
unsigned long | getFrames (void) const
| Return the number of sample frames output.
MY_FLOAT | getTime (void) const
| Return the number of seconds of data output.
void | tick (MY_FLOAT sample)
| Output a single sample to all channels in a sample frame.
void | tick (const MY_FLOAT *vector, unsigned int vectorSize)
| Output each sample in vector to all channels in vectorSize sample frames.
void | tickFrame (const MY_FLOAT *frameVector, unsigned int frames=1)
| Output the frameVector of sample frames of the given length.

## Detailed Description

STK internet streaming output class.

This protected WvOut subclass can stream data over a network via a TCP socket connection. The data is converted to big-endian byte order, if necessary, before being transmitted.

TcpWvOut supports multi-channel data in interleaved format. It is important to distinguish the tick() methods, which output single samples to all channels in a sample frame, from the tickFrame() method, which takes a pointer to multi-channel sample frame data.

This class connects to a socket server, the port and IP address of which must be specified as constructor arguments. The default data type is signed 16-bit integers but any of the defined STK_FORMATs are permissible.

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 34 of file TcpWvOut.h.

## Constructor & Destructor Documentation

TcpWvOut::TcpWvOut | ( | int | port,
|  | const char * | hostname = "localhost",
|  | unsigned int | nChannels = 1,
|  | Stk::STK_FORMAT | format = STK_SINT16
| ) |

| Overloaded constructor which opens a network connection during instantiation. An StkError is thrown if a socket error occurs or an invalid argument is specified.

## Member Function Documentation

void TcpWvOut::connect | ( | int | port,
|  | const char * | hostname = "localhost",
|  | unsigned int | nChannels = 1,
|  | Stk::STK_FORMAT | format = STK_SINT16
| ) |

| Connect to the specified host and port and prepare to stream nChannels of data in the given data format. An StkError is thrown if a socket error occurs or an invalid argument is specified.

void TcpWvOut::tick | ( | MY_FLOAT | sample | ) | `[virtual]`

| Output a single sample to all channels in a sample frame. An StkError is thrown if a socket write error occurs. Reimplemented from WvOut.

void TcpWvOut::tick | ( | const MY_FLOAT * | vector,
|  | unsigned int | vectorSize
| ) | `[virtual]`

| Output each sample in vector to all channels in vectorSize sample frames. An StkError is thrown if a socket write error occurs. Reimplemented from WvOut.

void TcpWvOut::tickFrame | ( | const MY_FLOAT * | frameVector,
|  | unsigned int | frames = 1
| ) | `[virtual]`

| Output the frameVector of sample frames of the given length. An StkError is thrown if a socket write error occurs. Reimplemented from WvOut.

The documentation for this class was generated from the following file:

- TcpWvOut.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.